# PBUG

This project contains a Puppet module that automates the application of
debugging configurations to Puppet and Puppet Enterprise services.

See the [usage section](#usage) for more details.

## Requirements

This module is compatible with Puppet 6.16.0 and newer, which translates to
PE 2019.8 and newer. Older versions of PE may work, but have not been tested.


## Usage

### pbug::mitmproxy

This class configures a SystemD service that uses [mitmproxy][mitmproxy]
to capture SSL traffic generated by local PE services for inspection.

Start the service with `systemctl start mitmproxy` and then visit
`http://<node ip address>:9080` to view captured traffic. Stop the
service when debugging is finished, otherwise it will buffer traffic
and consume resources until halted.

[mitmproxy]: https://mitmproxy.org
